#include "SDL.h"
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#include "fcgame.h"

//extern unsigned char whatplayer;

bool malcolm = false; //enable the ugly kid

void fade_out(){
	SDL_Surface *tmpsurface = SDL_DisplayFormat(screen);
	SDL_Surface *fadesurface = SDL_DisplayFormat(screen);
	
	SDL_BlitSurface(screen, NULL, tmpsurface, NULL);
	SDL_FillRect(fadesurface, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
	
	init_time();
	
	for(unsigned short fadealpha = 0; fadealpha <= 255; fadealpha+=5){
		if(!frameskip){
			SDL_SetAlpha(fadesurface, SDL_SRCALPHA, fadealpha);
			SDL_BlitSurface(tmpsurface, NULL, screen, NULL);
			SDL_BlitSurface(fadesurface, NULL, screen, NULL);
		}
		delay();
		if(!frameskip) SDL_Flip(screen);
	}
	
	//restore orriginal state (but don't update)
	SDL_BlitSurface(tmpsurface, NULL, screen, NULL);
	
	SDL_FreeSurface(tmpsurface);
	SDL_FreeSurface(fadesurface);
	clear_input();
	init_time();
}

void fade_in(){
	SDL_Surface *tmpsurface = SDL_DisplayFormat(screen);
	SDL_Surface *fadesurface = SDL_DisplayFormat(screen);

	SDL_FillRect(fadesurface, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
	
	init_time();
	
	for(unsigned long fadealpha = 255; fadealpha > 0; fadealpha -= 5){
		if(!frameskip){
			SDL_SetAlpha(fadesurface, SDL_SRCALPHA, fadealpha);
			SDL_BlitSurface(tmpsurface, NULL, screen, NULL);
			SDL_BlitSurface(fadesurface, NULL, screen, NULL);
		}
		delay();
		if(!frameskip) SDL_Flip(screen);
	}
	
	//restore orriginal state (but don't update)
	SDL_BlitSurface(tmpsurface, NULL, screen, NULL);
	
	SDL_FreeSurface(tmpsurface);
	SDL_FreeSurface(fadesurface);
	clear_input();
	init_time();
}

int character_choose(lua_State* luaS){
	fade_out();
	
	unsigned int step = 0;
	bool firstloop = true;
	
	if(whatplayer == 5){
		whatplayer = 0;
	}
	
	bool chosen = false;
	while(!chosen){
		SDL_Event event;
		
		SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 255, 255, 255));
		
		for(int i = 0; i < 5; i++){
			if(i == 4 && !malcolm){
				break;
			}
			//clear_tile(i*4 + 7, 0);
			if(i == whatplayer){
			
				unsigned short tilenum = character_start + i*13 + 2;
			
				if(step/TICK_PER_STEP == 0 || step/TICK_PER_STEP == 2){
					tilenum+=4;
				}else if(step/TICK_PER_STEP == 1){
					tilenum+=8;
				}
				
				do_print_sprite(tilenum, i*18*6 + 7*18, 0);
			}else{
				do_print_sprite(character_start + i*13 + 2 + 4, i*18*6 + 7*18, 0);
			}
		}
		
		step++;
		if(step/TICK_PER_STEP == 4){
			step = 0;
		}
		
		while(SDL_PollEvent(&event)){
			switch(event.type){
				case SDL_KEYDOWN:
					switch(event.key.keysym.sym){
						case SDLK_RETURN:
						case SDLK_SPACE:
							chosen = true;
							break;
						case SDLK_LEFT:
							if(whatplayer > 0){
								whatplayer--;
							}
							break;
						case SDLK_RIGHT:
							if(whatplayer < 3){
								whatplayer++;
							}else if(whatplayer == 3 && malcolm){
								whatplayer++;
							}
							break;
						case SDLK_q:
							exit(0);
							break;
						default :
							break;
					}
					break;
					
			
				case SDL_QUIT: {
					exit(0);
				}
			}
		}
		if(firstloop){
			fade_in();
			firstloop = false;
		}
		delay();
		SDL_Flip(screen);
	}
	player->tileid = players_tile_start;
	
	fade_out();
	
	SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
	
	drawscreen();
	
	do_updatebuffer();
	
	fade_in();
	
	update();

	lua_pushnumber(luaS, whatplayer+1);
	
	init_time();
	return 1;
}
