#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <lua.h>
#include <string.h>
#include <lualib.h>
#include <lauxlib.h>

#include "fcgame.h"

#include "pluto/pluto.h"

int donothing(lua_State* luaS){
	printf("ERROR\n");
	return 0;
}

void lua_docall(char *function){
	//lua_getglobal(luaVM, function);
	//lua_insert(luaVM, 1);
	//lua_call(luaVM, lua_gettop(luaVM)-1, LUA_MULTRET);
	lua_dostring(luaVM, function);
}

void init_scripting(){
	luaVM = lua_open();
	
	if(luaVM == NULL){
		printf("Error Initializing lua\n");
		exit(0);
	}
	
	luaopen_base(luaVM);
	luaopen_table(luaVM);
	luaopen_string(luaVM);
	luaopen_math(luaVM);
	luaopen_io(luaVM);
	luaopen_debug(luaVM);
	pluto_open(luaVM);
	lua_settop(luaVM, 0);
	
	lua_dofile(luaVM, "scripts/defaults.lua");
}

bool scripting_loadfile(char *filename){
	if(luaL_loadfile(luaVM, filename)){
		printf("could not load script %s\n", filename);
		exit(0);
		return false;
	}
	
	scripting_addfunctions();
		
	lua_pcall(luaVM, 0, LUA_MULTRET, 0);
	
	return true;
}

void entity_action(entity_t *entity, char *action){
	char luastring[80];
	strcpy(luastring, entity->name);
	strcat(luastring, ":");
	strcat(luastring, action);
	strcat(luastring,"()");
	lua_docall(&luastring[0]);
	/*lua_getglobal(luaVM, &luastring[0]);
	lua_insert(luaVM, 1);
	lua_call(luaVM, lua_gettop(luaVM)-1, LUA_MULTRET);*/
	
}
