#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>

#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"

#include "fcgame.h"

int filewriter(lua_State *L, const void* buf, size_t size, void* ud){
	fwrite(buf, size, 1, (FILE *)ud);
	return 0;
}

void savegame_scripts(int slot){
	char *save = malloc(160);
	
	sprintf(save, "save(\"saves/save%.2d.fcs\",%u,%u,%u)", slot, player->x, player->y, player->direction);
	
	printf("saving...\n");
	
	lua_dostring(luaVM, save);
	
	sprintf(save, "saves/save%.2d.sav", slot);
	
	FILE *file;
	
	file = fopen(save, "w");
	if(file == NULL){
		printf("Unable to open %s", save);
 		exit(0);
	}
	
	fwrite(current_map, 16, 1, file);
	fclose(file);
}

void loadgame_scripts(int slot){
	char *load = malloc(160);
	
	/////////////////////////////////////////////////////////
	sprintf(load, "saves/save%.2d.sav", slot);
	
	FILE *file = fopen(load, "r");
	if(file == NULL){
		printf("Unable to open %s\n", load);
 		exit(0);
	}
	
	fread(current_map, 16, 1, file);
	fclose(file);
	
	init_scripting();
	loadmap(current_map);
	
	///////////////////////////////////////////////////////////////
	
	sprintf(load, "load(\"saves/save%.2d.fcs\")", slot);
	free_entities();
	lua_dostring(luaVM, load);
}

void do_savegame(int slot){
	printf("=============================================================\n");
	savegame_scripts(slot);
}

void do_loadgame(int slot){
	SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
	printf("=============================================================\n");
	free_entities();
	loadgame_scripts(slot);
	reload_entities();
	drawscreen();
}

void savegame(){
	int menusel;
	menusel = menu("Slot #1\nSlot #2\nSlot #3\nSlot #4\ncancel", 14*7, (screen->h)-(18*12));
	switch(menusel){
		case 0:
		case 5:
			return;
		default:
			do_savegame(menusel-1);
		break;
	}
}

bool loadgame(){
	int menusel;
	menusel = menu("Slot #1\nSlot #2\nSlot #3\nSlot #4\ncancel", 14*7, (screen->h)-(18*12));
	switch(menusel){
		case 0:
		case 5:
			return false;
		default:
			do_loadgame(menusel-1);
		break;
	}
	return true;
}



