#include <stdlib.h>
#include <string.h>

#include "fcgame.h"
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"

int say_l(lua_State* luaS){
	char *string = (char *)lua_tostring(luaS, -1);
	do_say(string);
	SDL_Flip(screen);
	lua_pushnumber(luaS, 0);
	return 1;
}

void do_talk(){
	if((player->x)*TILEWIDTH != player->realx || (player->y)*TILEHEIGHT != player->realy) return;
	
	unsigned short x = player->x;
	unsigned short y = player->y;
	
	unsigned short otherdirection;
	
	switch(player->direction){
		case 0 :
			y--;
			otherdirection = 2;
			break;
		case 1 :
			x++;
			otherdirection = 3;
			break;
		case 2 :
			y++;
			otherdirection = 0;
			break;
		case 3 :
			x--;
			otherdirection = 1;
			break;
		default:
			return;
	}
	
	entity_t *entity = get_entity(x, y);
	
	if(entity == NULL){
		//printf("No one's there stupid\n");
	}else{
		//printf("%s: \n", entity);
		entity_face(entity, otherdirection);
		draw_tile(entity->x, entity->y);
		entity_action(entity, "talk");
	}
}

int get_whatplayer(lua_State* luaS){
	lua_pushnumber(luaS, whatplayer);
	return 1;
}

int set_whatplayer(lua_State* luaS){
	whatplayer = lua_tonumber(luaS, 1);
	player->tileid = players_tile_start;
	return 1;
}

void scripting_addfunctions(){
	lua_register(luaVM, "ccall_say", say_l);
	lua_register(luaVM, "character_choose", character_choose);
	
	lua_register(luaVM, "setup_player", setup_player);
	lua_register(luaVM, "create_entity", create_entity);
	
	lua_register(luaVM, "get_whatplayer", get_whatplayer);
	lua_register(luaVM, "set_whatplayer", set_whatplayer);
}


