#include "SDL.h"
#include <stdlib.h>

#include "fcgame.h"

void print_letter_h(char thechar, unsigned short x, unsigned short y){
	SDL_Rect srcrect = {(((thechar-' ')%16)*16), (((thechar-' ')/16)*18), 16, 18};
	SDL_Rect destrect = {x, y, 0, 0};
	
	//printf("%c", thechar);
	
	if(SDL_BlitSurface(highfont, &srcrect, screen, &destrect) < 0){
		fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());
	}
}

void print_letter(char thechar, unsigned short x, unsigned short y){
	SDL_Rect srcrect = {(((thechar-' ')%16)*16), (((thechar-' ')/16)*18), 16, 18};
	SDL_Rect destrect = {x, y, 0, 0};
	
	//printf("%c", thechar);
	
	if(SDL_BlitSurface(font, &srcrect, screen, &destrect) < 0){
		fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());
	}
}

void clear_text_box(){
	for(signed short y = screenheight-4; y < screenheight-1; y++){
		for(signed short x = 1; x < screenwidth-1; x++){
			do_clear_tile(x,y);
		}
	}
	
	for(signed short x = 1; x < screenwidth-1; x++){
		do_print_sprite(68, x*TILEWIDTH, (screenheight-5)*TILEHEIGHT);
		do_print_sprite(67, x*TILEWIDTH, (screenheight-1)*TILEHEIGHT);
	}
	
	for(signed short y = screenheight-4; y < screenheight-1; y++){
		do_print_sprite(65, 0, y*TILEHEIGHT);
		do_print_sprite(66, (screenwidth-1)*TILEWIDTH, y*TILEHEIGHT);
	}
	
	do_print_sprite(69, 0, (screenheight-5)*TILEHEIGHT);
	do_print_sprite(70, 0, (screenheight-1)*TILEHEIGHT);
	do_print_sprite(71, (screenwidth-1)*TILEWIDTH, (screenheight-5)*TILEHEIGHT);
	do_print_sprite(72, (screenwidth-1)*TILEWIDTH, (screenheight-1)*TILEHEIGHT);
	
	
}

//this function needs some work
void text_up(){
	do_print_sprite(73,(screenwidth-2)*TILEWIDTH,(screenheight-2)*TILEHEIGHT);
	
	SDL_Rect srcrect = {0, (screenheight-3)*TILEHEIGHT, screenwidth*TILEWIDTH, 3*TILEHEIGHT};
	SDL_Rect destrect = {0, (screenheight-4)*TILEHEIGHT, 0, 0};
	
	if(SDL_BlitSurface(screen, &srcrect, screen, &destrect) < 0){
		fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());
	}
	
	destrect.x = 10;
	destrect.y = (screenheight-1)*TILEHEIGHT-12;
	destrect.w = (screenwidth-1)*TILEWIDTH-2;
	destrect.h = 18;
	
	SDL_FillRect(screen, &destrect, SDL_MapRGB(screen->format, 255, 255, 255));
	
	for(signed short x = 1; x < screenwidth-1; x++){
		do_print_sprite(68, x*TILEWIDTH, (screenheight-5)*TILEHEIGHT);
		do_print_sprite(67, x*TILEWIDTH, (screenheight-1)*TILEHEIGHT);
	}
	
	do_print_sprite(70, 0, (screenheight-1)*TILEHEIGHT);
	do_print_sprite(72, (screenwidth-1)*TILEWIDTH, (screenheight-1)*TILEHEIGHT);
	
}

void say_line(char *string, unsigned short x, unsigned short y){
	unsigned short i = 0;
	while(*string){
		print_letter(*string, x+(i*12), y);
		
		i++;
		string++;
	}
}

void do_say(char *string){
	clear_text_box();
	SDL_Flip(screen);
	
	SDL_Event event;
	
	bool end = false;
	bool nextline = false;
	
	unsigned short i = 0;
	
	while(!end){
		SDL_Flip(screen);
		beep();
		
		nextline = 0;
		
		while(*string && *string != '\n' && i < 48*3){
			unsigned thespace = 0;
			
			while(string[thespace] != ' ' && string[thespace] != 0 && string[thespace] != '\n'){
				thespace++;
			}
			
			if((i%48)+thespace+3 >= 48 || string[thespace] == '\n'){
				i += 48-i%48;
			}
			
			if(i >= 48*3) break;
			
			while(*string != ' ' && *string != 0 && *string != '\n'){
				print_letter(*string, (i%48)*12+TILEWIDTH, ((screenheight-3)*TILEHEIGHT-10)+((i/48)*18));
				
				//SDL_Delay(10);
				SDL_UpdateRect(screen, (i%48)*12+TILEWIDTH, ((screenheight-3)*TILEHEIGHT-10)+((i/48)*18), 16, 18);
				
				i++;
				string++;
			}
			
			if(*string == 0) break;
			
			i++;
			
			string++;
		}
		
		if(*string){
			do_print_sprite(74,(screenwidth-2)*TILEWIDTH,(screenheight-2)*TILEHEIGHT);
		}else{
			do_print_sprite(75,(screenwidth-2)*TILEWIDTH,(screenheight-2)*TILEHEIGHT);
		}
		
		SDL_Flip(screen);
		
		clear_input();
		
		while(!nextline){
			while(SDL_PollEvent(&event)){
				switch(event.type){
					case SDL_KEYDOWN :
						switch(event.key.keysym.sym){
							case SDLK_q :
								nextline = true;
								end = true;
								break;
							case SDLK_RETURN:
							case SDLK_SPACE:
								nextline = true;
								break;
							default:
								break;
						}
						break;
						
					case SDL_QUIT: {
						exit(0);
					}
				}
			}
			SDL_Delay(10);//don't jack all the CPU
		}
		if(!*string) end = true;
		
		if(!end){
			text_up();
			if(i%48 == 0){
				i -= 48;
			}else{
				i -= i%48;
			}
		}
		if(*string == '\n'){
			string++;
		}
	}
	
	for(signed short y = stupiddiv(screeny)+screenheight-4; y <= stupiddiv(screeny)+screenheight; y++){
		for(signed short x = stupiddiv(screenx); x <= stupiddiv(screenx)+screenwidth; x++){
			draw_tile(x,y);
		}
	}
	
	init_time();//reset the timer
}
